from sqlobject import *

class Category(SQLObject):
    key = 'id'
    names = 'categories'
    _cacheValues = False

    name = StringCol(length = 100)

    def migrateOldData(cls):
        import storage
        from formdef import FormDef
        from consultationdef import Consultation

        init_method = cls.__init__
        cls.__init__ = lambda x: x
        categories = storage.get_storage().values('categories')
        items = [x.__dict__ for x in categories]
        cls.__init__ = init_method

        new_ids_mapping = []
        for item in items:
            category = Category(name = item['name'])
            new_ids_mapping.append( (item['id'], category.id) )

        # fixing other tables to get the new ids
        # formdefs
        formdef_init_method = FormDef.__init__
        FormDef.__init__ = lambda x: x
        formdefs = storage.get_storage().values('formdefs')
        for formdef in formdefs:
            cat = formdef.__dict__.get('category')
            if not cat:
                formdef.__dict__['category'] = None
            else:
                formdef.__dict__['category'] = [x[1] for x in new_ids_mapping if x[0] == cat][0]
            storage.get_storage().store(formdef)
        FormDef.__init__ = formdef_init_method

        # consultations
        consultation_init_method = Consultation.__init__
        Consultation.__init__ = lambda x: x
        consultations = storage.get_storage().values('consultations')
        for consultation in consultations:
            cat = consultation.__dict__['category']
            if not cat:
                consultation.__dict__['category'] = None
            else:
                consultation.__dict__['category'] = [x[1] for x in new_ids_mapping if x[0] == cat][0]
            storage.get_storage().store(consultation)
        Consultation.__init__ = consultation_init_method

    migrateOldData = classmethod(migrateOldData)
